package gregapi.recipes;

import static gregapi.data.CS.*;
import gregapi.api.Abstract_Mod;
import gregapi.code.ArrayListNoNulls;
import gregapi.code.IItemContainer;
import gregapi.config.ConfigCategories;
import gregapi.data.*;
import gregapi.data.CS.ConfigsGT;
import gregapi.data.CS.ItemsGT;
import gregapi.data.CS.OreDictToolNames;
import gregapi.data.CS.ToolsGT;
import gregapi.item.IItemDamagable;
import gregapi.oredict.OreDictItemData;
import gregapi.oredict.OreDictManager;
import gregapi.oredict.OreDictMaterial;
import gregapi.recipes.Recipe.RecipeMap;
import gregapi.util.OM;
import gregapi.util.UT;
import ic2.api.item.IElectricItem;
import ic2.api.recipe.IRecipeInput;
import ic2.api.recipe.RecipeOutput;

import java.util.*;
import java.util.Map.Entry;

import net.minecraft.enchantment.Enchantment;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.*;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.oredict.OreDictionary;
import net.minecraftforge.oredict.ShapedOreRecipe;
import net.minecraftforge.oredict.ShapelessOreRecipe;
import cpw.mods.fml.common.event.FMLInterModComms;
import cpw.mods.fml.common.registry.GameRegistry;

/**
 * @author Gregorius Techneticies
 */
public class GT_ModHandler {
	public static boolean addSawingRecipe(long aEUt, long aDuration, boolean aIsFoodItem, long aLubricantAmount, ItemStack aInput, ItemStack... aOutputs) {
		if (UT.Stacks.invalid(aInput) || aOutputs.length <= 0 || UT.Stacks.invalid(aOutputs[0])) return F;
		if (aLubricantAmount <= 0) aLubricantAmount = 1;
		
        FluidStack[] tFluids = new FluidStack[] {UT.Fluids.water(4000), UT.Fluids.distilledwater(4000), MT.Lubricant.liquid(U, T), UT.Fluids.make("rc lubricant", 1000)};
        long[] tTime = new long[] {4, 3, 1, 1};
        
        for (byte i = 0; i < tFluids.length; i++) if (tFluids[i] != null && (!aIsFoodItem || i <= 2)) RecipeMap.sCutterRecipes.addRecipe1(T, aEUt, aDuration*tTime[i], aInput, UT.Fluids.mul(tFluids[i], aLubricantAmount, 1000, T), NF, aOutputs);
        
		return F;
	}
	
	public static boolean addFoodCanningRecipe(ItemStack aStack, int aFoodValue, String aCannedName, IItemContainer... aCans) {
		if (UT.Stacks.invalid(aStack) || aStack.getItem() == ItemsGT.sMultiItemCans || IL.IC2_Food_Can_Filled.equal(aStack, T, T)) return F;
		if (aFoodValue > 0) switch(aFoodValue / 2) {
	    case  0: case  1:										return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(1), aCans[0].getWithName(1, aCannedName), UT.Stacks.container(aStack, T));
    	case  2:												return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(1), aCans[1].getWithName(1, aCannedName), UT.Stacks.container(aStack, T));
        case  3:												return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(1), aCans[2].getWithName(1, aCannedName), UT.Stacks.container(aStack, T));
        case  4:												return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(1), aCans[3].getWithName(1, aCannedName), UT.Stacks.container(aStack, T));
        case  5:												return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(1), aCans[4].getWithName(1, aCannedName), UT.Stacks.container(aStack, T));
        case  8: case  9:										return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(2), aCans[3].getWithName(2, aCannedName), UT.Stacks.container(aStack, T));
        case 10: case 11:										return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(2), aCans[4].getWithName(2, aCannedName), UT.Stacks.container(aStack, T));
        case 15: case 16: case 17:								return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(3), aCans[4].getWithName(3, aCannedName), UT.Stacks.container(aStack, T));
        case 20: case 21: case 22: case 23:						return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(4), aCans[4].getWithName(4, aCannedName), UT.Stacks.container(aStack, T));
        case 25: case 26: case 27: case 28: case 29:			return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(5), aCans[4].getWithName(5, aCannedName), UT.Stacks.container(aStack, T));
        default:												return null != RecipeMap.sCannerRecipes.addRecipe2(T, 16, 16, aStack, IL.Food_Can_Empty.get(aFoodValue/12), aCans[5].getWithName(aFoodValue/12, aCannedName), UT.Stacks.container(aStack, T));
	    }
		return F;
	}
	
	/**
	 * Just simple Furnace smelting. Unbelievable how Minecraft fails at making a simple ItemStack->ItemStack mapping...
	 */
	public static boolean addSmeltingRecipe(ItemStack aInput, ItemStack aOutput) {
		if (UT.Stacks.invalid(aInput) || UT.Stacks.invalid(aOutput)) return F;
		aOutput = OM.get_(aOutput);
		if (UT.Stacks.container(aInput, F) != null || UT.Stacks.equal_(aInput, aOutput, F) || !ConfigsGT.RECIPES.get(ConfigCategories.Machines.smelting, aInput, T)) return F;
		FurnaceRecipes.smelting().func_151394_a(aInput, UT.Stacks.copy(aOutput), 0.0F);
		return T;
	}
	
	/**
	 * LiquidTransposer Recipe for both directions
	 */
	public static boolean addLiquidTransposerRecipe(ItemStack aEmptyContainer, FluidStack aLiquid, ItemStack aFullContainer, int aMJ) {
		if (UT.Stacks.invalid(aEmptyContainer) || UT.Stacks.invalid(aFullContainer) || aLiquid == null) return F;
		aFullContainer = OM.get_(aFullContainer);
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.liquidtransposer, aFullContainer, T)) return F;
		try {
			ThermalExpansion.addTransposerFill(aMJ*10, aEmptyContainer, aFullContainer, aLiquid, T);
		} catch(Throwable e) {/*Do nothing*/}
		return T;
	}
	
	/**
	 * LiquidTransposer Recipe for filling Containers
	 */
	public static boolean addLiquidTransposerFillRecipe(ItemStack aEmptyContainer, FluidStack aLiquid, ItemStack aFullContainer, int aMJ) {
		if (UT.Stacks.invalid(aEmptyContainer) || UT.Stacks.invalid(aFullContainer) || aLiquid == null) return F;
		aFullContainer = OM.get_(aFullContainer);
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.liquidtransposerfilling, aFullContainer, T)) return F;
		try {
			ThermalExpansion.addTransposerFill(aMJ*10, aEmptyContainer, aFullContainer, aLiquid, F);
		} catch(Throwable e) {/*Do nothing*/}
		return T;
	}
	
	/**
	 * LiquidTransposer Recipe for emptying Containers
	 */
	public static boolean addLiquidTransposerEmptyRecipe(ItemStack aFullContainer, FluidStack aLiquid, ItemStack aEmptyContainer, int aMJ) {
		if (UT.Stacks.invalid(aFullContainer) || UT.Stacks.invalid(aEmptyContainer) || aLiquid == null) return F;
		aEmptyContainer = OM.get_(aEmptyContainer);
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.liquidtransposeremptying, aFullContainer, T)) return F;
		try {
			ThermalExpansion.addTransposerExtract(aMJ*10, aFullContainer, aEmptyContainer, aLiquid, 100, F);
		} catch(Throwable e) {/*Do nothing*/}
		return T;
	}
	
	/**
	 * IC2-Extractor Recipe. Overloads old Recipes automatically
	 */
	public static boolean addExtractionRecipe(ItemStack aInput, ItemStack aOutput) {
		if (UT.Stacks.invalid(aInput) || UT.Stacks.invalid(aOutput)) return F;
		aOutput = OM.get_(aOutput);
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.extractor, aInput, T)) {
			UT.removeSimpleIC2MachineRecipe(aInput, getExtractorRecipeList(), null);
			return F;
		}
		UT.addSimpleIC2MachineRecipe(ic2.api.recipe.Recipes.extractor, aInput, null, aOutput);
		return T;
	}
	
	/**
	 * RC-BlastFurnace Recipes
	 */
	public static boolean addRCBlastFurnaceRecipe(ItemStack aInput, ItemStack aOutput, int aTime) {
		if (UT.Stacks.invalid(aInput) || UT.Stacks.invalid(aOutput) || aTime <= 0) return F;
		aOutput = OM.get_(aOutput);
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.rcblastfurnace, aInput, T)) return F;
		aInput = UT.Stacks.copy(aInput);
		aOutput = UT.Stacks.copy(aOutput);
		try {
			mods.railcraft.api.crafting.RailcraftCraftingManager.blastFurnace.addRecipe(aInput, T, F, aTime, aOutput);
		} catch (Throwable e) {
			return F;
		}
		return T;
	}
	
	public static boolean addPulverisationRecipe(ItemStack aInput, ItemStack aOutput1) {
		return addPulverisationRecipe(aInput, aOutput1, null, 0, F);
	}
	
	public static boolean addPulverisationRecipe(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2) {
		return addPulverisationRecipe(aInput, aOutput1, aOutput2, 100, F);
	}
	
	public static boolean addPulverisationRecipe(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2, int aChance) {
		return addPulverisationRecipe(aInput, aOutput1, aOutput2, aChance, F);
	}
	
	public static boolean addPulverisationRecipe(ItemStack aInput, ItemStack aOutput1, boolean aOverwrite) {
		return addPulverisationRecipe(aInput, aOutput1, null, 0, aOverwrite);
	}

	public static boolean addPulverisationRecipe(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2, boolean aOverwrite) {
		return addPulverisationRecipe(aInput, aOutput1, aOutput2, 100, aOverwrite);
	}
	
	public static boolean addPulverisationRecipe(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2, int aChance, boolean aOverwrite) {
		return addPulverisationRecipe(aInput, aOutput1, aOutput2, aChance, null, 0, aOverwrite);
	}
	
	/**
	 * Adds Several Pulverizer-Type Recipes.
	 */
	public static boolean addPulverisationRecipe(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2, int aChance2, ItemStack aOutput3, int aChance3, boolean aOverwrite) {
		if (UT.Stacks.invalid(aInput) || UT.Stacks.invalid(aOutput1)) return F;
		aOutput1 = OM.get_(aOutput1);
		aOutput2 = OM.get(aOutput2);
		
		if (UT.Stacks.container(aInput, F) == null) {
			if (ConfigsGT.RECIPES.get(ConfigCategories.Machines.maceration, aInput, T)) {
				UT.addSimpleIC2MachineRecipe(ic2.api.recipe.Recipes.macerator, aInput, null, aOutput1);
			} else {
				UT.removeSimpleIC2MachineRecipe(aInput, getMaceratorRecipeList(), null);
			}
			
			if (!OP.log.contains(aInput)) {
				if (MT.Wood.contains(aOutput1)) {
					if (ConfigsGT.RECIPES.get(ConfigCategories.Machines.pulverization, aInput, T)) {
						if (aOutput2 == null)
							ThermalExpansion.addSawmillRecipe(32000, UT.Stacks.copy(aInput), UT.Stacks.copy(aOutput1));
						else
							ThermalExpansion.addSawmillRecipe(32000, UT.Stacks.copy(aInput), UT.Stacks.copy(aOutput1), UT.Stacks.copy(aOutput2), aChance2<=0?10:aChance2);
					}
				} else {
					if (ConfigsGT.RECIPES.get(ConfigCategories.Machines.rockcrushing, aInput, UT.Stacks.block(aInput) != NB)) {
						try {
							if (UT.Stacks.block(aInput) != Blocks.obsidian && UT.Stacks.block(aInput) != Blocks.gravel) {
								mods.railcraft.api.crafting.IRockCrusherRecipe tRecipe = mods.railcraft.api.crafting.RailcraftCraftingManager.rockCrusher.createNewRecipe(UT.Stacks.amount(1, aInput), UT.Stacks.meta(aInput) != W, F);
								tRecipe.addOutput(UT.Stacks.copy(aOutput1), 1.0F/aInput.stackSize);
								if (aOutput2 != null) tRecipe.addOutput(UT.Stacks.copy(aOutput2), (0.01F*(aChance2<=0?10:aChance2))/aInput.stackSize);
								if (aOutput3 != null) tRecipe.addOutput(UT.Stacks.copy(aOutput3), (0.01F*(aChance3<=0?10:aChance3))/aInput.stackSize);
							}
						} catch(Throwable e) {/*Do nothing*/}
					}
					if (ConfigsGT.RECIPES.get(ConfigCategories.Machines.pulverization, aInput, T)) {
						if (aOutput2 == null)
							ThermalExpansion.addPulverizerRecipe(32000, UT.Stacks.copy(aInput), UT.Stacks.copy(aOutput1));
						else
							ThermalExpansion.addPulverizerRecipe(32000, UT.Stacks.copy(aInput), UT.Stacks.copy(aOutput1), UT.Stacks.copy(aOutput2), aChance2<=0?10:aChance2);
					}
				}
			}
		}
		return T;
	}
	
	/**
	 * Adds a Recipe to the Sawmills of GregTech and ThermalCraft
	 */
	public static boolean addSawmillRecipe(ItemStack aInput, ItemStack aOutput1, ItemStack aOutput2) {
		if (UT.Stacks.invalid(aInput) || UT.Stacks.invalid(aOutput1)) return F;
		aOutput1 = OM.get_(aOutput1);
		aOutput2 = OM.get(aOutput2);
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.sawmill, aInput, T)) return F;
	    try {
	    	ThermalExpansion.addSawmillRecipe(1600, aInput, aOutput1, aOutput2, 100);
		} catch(Throwable e) {/*Do nothing*/}
		return T;
	}
	
	/**
	 * Induction Smelter Recipes and Alloy Smelter Recipes
	 */
	public static boolean addAlloySmelterRecipe(ItemStack aInput1, ItemStack aInput2, ItemStack aOutput1, int aDuration, int aEUt, boolean aAllowSecondaryInputEmpty) {
		if (aInput1 == null || (aInput2 == null && !aAllowSecondaryInputEmpty) || UT.Stacks.invalid(aOutput1)) return F;
		aOutput1 = OM.get_(aOutput1);
		boolean temp = F;
		if (addInductionSmelterRecipe(aInput1, aInput2, aOutput1, null, aDuration * aEUt * 2, 0)) temp = T;
		return temp;
	}
	
	/**
	 * Induction Smelter Recipes for TE
	 */
	public static boolean addInductionSmelterRecipe(ItemStack aInput1, ItemStack aInput2, ItemStack aOutput1, ItemStack aOutput2, int aEnergy, int aChance) {
		if (UT.Stacks.invalid(aInput1 == null) || UT.Stacks.invalid(aOutput1)) return F;
		aOutput1 = OM.get_(aOutput1);
		aOutput2 = OM.get(aOutput2);
		if (UT.Stacks.container(aInput1, F) != null || !ConfigsGT.RECIPES.get(ConfigCategories.Machines.inductionsmelter, aInput2==null?aInput1:aOutput1, T)) return F;
	    try {
	    	ThermalExpansion.addSmelterRecipe(aEnergy*10, UT.Stacks.copy(aInput1), aInput2==null?UT.Stacks.make(Blocks.sand, 1, 0):aInput2, aOutput1, aOutput2, aChance);
		} catch(Throwable e) {/*Do nothing*/}
		return T;
	}
	
	private static Map<IRecipeInput, RecipeOutput>	sExtractorRecipes			= new HashMap<IRecipeInput, RecipeOutput>();
	private static Map<IRecipeInput, RecipeOutput>	sMaceratorRecipes			= new HashMap<IRecipeInput, RecipeOutput>();
	private static Map<IRecipeInput, RecipeOutput>	sCompressorRecipes			= new HashMap<IRecipeInput, RecipeOutput>();
	private static Map<IRecipeInput, RecipeOutput>	sOreWashingRecipes			= new HashMap<IRecipeInput, RecipeOutput>();
	private static Map<IRecipeInput, RecipeOutput>	sThermalCentrifugeRecipes	= new HashMap<IRecipeInput, RecipeOutput>();
	private static Map<IRecipeInput, RecipeOutput>	sMassfabRecipes				= new HashMap<IRecipeInput, RecipeOutput>();
	
	public static Map<IRecipeInput, RecipeOutput> getExtractorRecipeList() {
		try {
			return ic2.api.recipe.Recipes.extractor.getRecipes();
		} catch(Throwable e) {/*Do nothing*/}
		return sExtractorRecipes;
	}
	
	public static Map<IRecipeInput, RecipeOutput> getCompressorRecipeList() {
		try {
			return ic2.api.recipe.Recipes.compressor.getRecipes();
		} catch(Throwable e) {/*Do nothing*/}
		return sCompressorRecipes;
	}
	
	public static Map<IRecipeInput, RecipeOutput> getMaceratorRecipeList() {
		try {
			return ic2.api.recipe.Recipes.macerator.getRecipes();
		} catch(Throwable e) {/*Do nothing*/}
		return sMaceratorRecipes;
	}

	public static Map<IRecipeInput, RecipeOutput> getThermalCentrifugeRecipeList() {
		try {
			return ic2.api.recipe.Recipes.centrifuge.getRecipes();
		} catch(Throwable e) {/*Do nothing*/}
		return sThermalCentrifugeRecipes;
	}
	
	public static Map<IRecipeInput, RecipeOutput> getOreWashingRecipeList() {
		try {
			return ic2.api.recipe.Recipes.oreWashing.getRecipes();
		} catch(Throwable e) {/*Do nothing*/}
		return sOreWashingRecipes;
	}
	
	public static Map<IRecipeInput, RecipeOutput> getMassFabricatorList() {
		try {
			return ic2.api.recipe.Recipes.matterAmplifier.getRecipes();
		} catch(Throwable e) {/*Do nothing*/}
		return sMassfabRecipes;
	}
	
	/**
	 * IC2-ThermalCentrifuge Recipe. Overloads old Recipes automatically
	 */
	public static boolean addThermalCentrifugeRecipe(ItemStack aInput, long aHeat, Object... aOutput) {
		if (UT.Stacks.invalid(aInput) || aOutput == null || aOutput.length <= 0 || aOutput[0] == null) return F;
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.thermalcentrifuge, aInput, T)) {
			UT.removeSimpleIC2MachineRecipe(aInput, getThermalCentrifugeRecipeList(), null);
			return F;
		}
		UT.addSimpleIC2MachineRecipe(ic2.api.recipe.Recipes.centrifuge, aInput, UT.NBT.getNBTLong(null, "minHeat", aHeat), aOutput);
		return T;
	}
	
	/**
	 * IC2-OreWasher Recipe. Overloads old Recipes automatically
	 */
	public static boolean addOreWasherRecipe(ItemStack aInput, long aWaterAmount, Object... aOutput) {
		if (UT.Stacks.invalid(aInput) || aOutput == null || aOutput.length <= 0 || aOutput[0] == null) return F;
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.orewashing, aInput, T)) {
			UT.removeSimpleIC2MachineRecipe(aInput, getOreWashingRecipeList(), null);
			return F;
		}
		UT.addSimpleIC2MachineRecipe(ic2.api.recipe.Recipes.oreWashing, aInput, UT.NBT.getNBTLong(null, "amount", aWaterAmount), aOutput);
		return T;
	}
	
	/**
	 * IC2-Compressor Recipe. Overloads old Recipes automatically
	 */
	public static boolean addCompressionRecipe(ItemStack aInput, ItemStack aOutput) {
		if (UT.Stacks.invalid(aInput) || UT.Stacks.invalid(aOutput)) return F;
		aOutput = OM.get_(aOutput);
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.compression, aInput, T)) {
			UT.removeSimpleIC2MachineRecipe(aInput, getCompressorRecipeList(), null);
			return F;
		}
		UT.addSimpleIC2MachineRecipe(ic2.api.recipe.Recipes.compressor, aInput, null, aOutput);
		return T;
	}
	
	/**
	 * @param aValue Scrap = 5000, Scrapbox = 45000, Diamond Dust 125000
	 */
	public static boolean addIC2MatterAmplifier(ItemStack aAmplifier, int aValue) {
		if (aAmplifier == null || aValue <= 0) return F;
		if (!ConfigsGT.RECIPES.get(ConfigCategories.Machines.massfabamplifier, aAmplifier, T)) return F;
		try {
			NBTTagCompound tNBT = new NBTTagCompound();
			tNBT.setInteger("amplification", aValue);
			UT.Reflection.callMethod(ic2.api.recipe.Recipes.matterAmplifier, "addRecipe", F, F, F, aAmplifier, tNBT);
		} catch(Throwable e) {/*Do nothing*/}
		return T;
	}
	
	/**
	 * Rolling Machine Crafting Recipe
	 */
	public static boolean addRollingMachineRecipe(ItemStack aResult, Object[] aRecipe) {
		if (UT.Stacks.invalid(aResult) || aRecipe == null || aResult.stackSize <= 0) return F;
		aResult = OM.get_(aResult);
		try {
			mods.railcraft.api.crafting.RailcraftCraftingManager.rollingMachine.getRecipeList().add(new ShapedOreRecipe(UT.Stacks.copy(aResult), aRecipe));
		} catch(Throwable e) {
			return addCraftingRecipe(UT.Stacks.copy(aResult), aRecipe);
		}
		return T;
	}
	
	private static boolean sBufferCraftingRecipes = T;
	public static final List<IRecipe> sAllRecipeList = Collections.synchronizedList(new ArrayListNoNulls<IRecipe>(5000));
	private static final List<IRecipe> sBufferRecipeList = new ArrayListNoNulls<IRecipe>(1000);
	
	public static void stopBufferingCraftingRecipes() {
		sBufferCraftingRecipes = F;
		for (IRecipe tRecipe : sBufferRecipeList) GameRegistry.addRecipe(tRecipe);
		sBufferRecipeList.clear();
	}
	
	public static class RecipeBits {
		/** Mirrors the Recipe */
		public static long MIRRORED = B[0];
		/** Buffers the Recipe for later addition. This makes things more efficient. */
		public static long BUFFERED = B[1];
		/** This is a special Tag I used for crafting Coins up and down. */
		public static long KEEPNBT = B[2];
		/** Makes the Recipe Reverse Craftable in the Disassembler. */
		public static long DISMANTLEABLE = B[3];
		/** Prevents the Recipe from accidentally getting removed by my own Handlers. */
		public static long NOT_REMOVABLE = B[4];
		/** Reverses the Output of the Recipe for smelting and pulverising. */
		public static long REVERSIBLE = B[5];
		/** Removes all Recipes with the same Output Item regardless of NBT, unless another Recipe Deletion Bit is added too. */
		public static long DELETE_ALL_OTHER_RECIPES = B[6];
		/** Removes all Recipes with the same Output Item limited to the same NBT. */
		public static long DELETE_ALL_OTHER_RECIPES_IF_SAME_NBT = B[7];
		/** Removes all Recipes with the same Output Item limited to Shaped Recipes. */
		public static long DELETE_ALL_OTHER_SHAPED_RECIPES = B[8];
		/** Removes all Recipes with the same Output Item limited to native Recipe Handlers. */
		public static long DELETE_ALL_OTHER_NATIVE_RECIPES = B[9];
		/** Disables the check for colliding Recipes. */
		public static long DO_NOT_CHECK_FOR_COLLISIONS = B[10];
		/** Only adds the Recipe if there is another Recipe having that Output */
		public static long ONLY_ADD_IF_THERE_IS_ANOTHER_RECIPE_FOR_IT = B[11];
		/** Only adds the Recipe if it has an Output */
		public static long ONLY_ADD_IF_RESULT_IS_NOT_NULL = B[12];
		/** Removes only if no OreDict Dye List is used. */
		public static long DELETE_ONLY_IF_NO_DYE_IS_INVOLVED = B[13];
		/** Prevents the Recipe from being AutoCrafted by GT. */
		public static long NOT_AUTOCRAFTABLE = B[14];
		
		public static long DEFAULT = BUFFERED|NOT_REMOVABLE;
		public static long DEFAULT_REV = DEFAULT|REVERSIBLE;
		public static long DEFAULT_NCC = DEFAULT|DO_NOT_CHECK_FOR_COLLISIONS;
		public static long DEFAULT_REV_NCC = DEFAULT_REV|DO_NOT_CHECK_FOR_COLLISIONS;
	}
	
	/**
	 * Shapeless Crafting Recipes. Deletes conflicting Recipes too.
	 */
	public static boolean addCraftingRecipe(ItemStack aResult, Enchantment[] aEnchantmentsAdded, int[] aEnchantmentLevelsAdded, Object[] aRecipe) {
		return addCraftingRecipe(aResult, aEnchantmentsAdded, aEnchantmentLevelsAdded, F, T, F, F, F, F, F, F, F, F, F, F, T, F, F, aRecipe);
	}
	
	/**
	 * Regular Crafting Recipes. Deletes conflicting Recipes too.
	 * 
	 * You can insert instances of IItemContainer into the Recipe Input Array directly without having to call "get(1)" on them.
	 * 
	 * Enums are automatically getting their "name()"-Method called in order to deliver an OreDict String.
	 * 
	 * Lowercase Letters are reserved for Tools. They are as follows:
	 * 
	 * 'b' ToolDictNames.craftingToolBlade
	 * 'c' ToolDictNames.craftingToolCrowbar,
	 * 'd' ToolDictNames.craftingToolScrewdriver,
	 * 'f' ToolDictNames.craftingToolFile,
	 * 'h' ToolDictNames.craftingToolHardHammer,
	 * 'i' ToolDictNames.craftingToolSolderingIron,
	 * 'j' ToolDictNames.craftingToolSolderingMetal,
	 * 'k' ToolDictNames.craftingToolKnive
	 * 'm' ToolDictNames.craftingToolMortar,
	 * 'n' ToolDictNames.craftingToolMonkeyWrench,
	 * 'o' ToolDictNames.craftingToolBendingCylinderSmall,
	 * 'p' ToolDictNames.craftingToolDrawplate,
	 * 'r' ToolDictNames.craftingToolSoftHammer,
	 * 's' ToolDictNames.craftingToolSaw,
	 * 'w' ToolDictNames.craftingToolWrench,
	 * 'x' ToolDictNames.craftingToolWireCutter,
	 * 'y' ToolDictNames.craftingToolChisel,
	 * 'z' ToolDictNames.craftingToolBendingCylinder
	 */
	public static boolean addCraftingRecipe(ItemStack aResult, Object[] aRecipe) {
		return addCraftingRecipe(aResult, 0, aRecipe);
	}
	
	/**
	 * Regular Crafting Recipes. Deletes conflicting Recipes too.
	 * 
	 * You can insert instances of IItemContainer into the Recipe Input Array directly without having to call "get(1)" on them.
	 * 
	 * Enums are automatically getting their "name()"-Method called in order to deliver an OreDict String.
	 * 
	 * Lowercase Letters are reserved for Tools. They are as follows:
	 * 
	 * 'b' ToolDictNames.craftingToolBlade
	 * 'c' ToolDictNames.craftingToolCrowbar,
	 * 'd' ToolDictNames.craftingToolScrewdriver,
	 * 'f' ToolDictNames.craftingToolFile,
	 * 'h' ToolDictNames.craftingToolHardHammer,
	 * 'i' ToolDictNames.craftingToolSolderingIron,
	 * 'j' ToolDictNames.craftingToolSolderingMetal,
	 * 'k' ToolDictNames.craftingToolKnive
	 * 'l' ToolDictNames.craftingToolMagnifyingGlass
	 * 'm' ToolDictNames.craftingToolMortar,
	 * 'n' ToolDictNames.craftingToolMonkeyWrench,
	 * 'o' ToolDictNames.craftingToolBendingCylinderSmall,
	 * 'p' ToolDictNames.craftingToolDrawplate,
	 * 'r' ToolDictNames.craftingToolSoftHammer,
	 * 's' ToolDictNames.craftingToolSaw,
	 * 'w' ToolDictNames.craftingToolWrench,
	 * 'x' ToolDictNames.craftingToolWireCutter,
	 * 'y' ToolDictNames.craftingToolChisel,
	 * 'z' ToolDictNames.craftingToolBendingCylinder
	 */
	public static boolean addCraftingRecipe(ItemStack aResult, long aBitMask, Object[] aRecipe) {
		return addCraftingRecipe(aResult, new Enchantment[0], new int[0], (aBitMask & RecipeBits.MIRRORED) != 0, (aBitMask & RecipeBits.BUFFERED) != 0, (aBitMask & RecipeBits.KEEPNBT) != 0, (aBitMask & RecipeBits.DISMANTLEABLE) != 0, (aBitMask & RecipeBits.NOT_REMOVABLE) == 0, (aBitMask & RecipeBits.REVERSIBLE) != 0, (aBitMask & RecipeBits.DELETE_ALL_OTHER_RECIPES) != 0, (aBitMask & RecipeBits.DELETE_ALL_OTHER_RECIPES_IF_SAME_NBT) != 0, (aBitMask & RecipeBits.DELETE_ALL_OTHER_SHAPED_RECIPES) != 0, (aBitMask & RecipeBits.DELETE_ALL_OTHER_NATIVE_RECIPES) != 0, (aBitMask & RecipeBits.DO_NOT_CHECK_FOR_COLLISIONS) == 0, (aBitMask & RecipeBits.ONLY_ADD_IF_THERE_IS_ANOTHER_RECIPE_FOR_IT) != 0, (aBitMask & RecipeBits.ONLY_ADD_IF_RESULT_IS_NOT_NULL) != 0, (aBitMask & RecipeBits.DELETE_ONLY_IF_NO_DYE_IS_INVOLVED) != 0, (aBitMask & RecipeBits.NOT_AUTOCRAFTABLE) != 0, aRecipe);
	}
	
	/**
	 * Internal realisation of the Crafting Recipe adding Process.
	 */
	private static boolean addCraftingRecipe(ItemStack aResult, Enchantment[] aEnchantmentsAdded, int[] aEnchantmentLevelsAdded, boolean aMirrored, boolean aBuffered, boolean aKeepNBT, boolean aDismantleable, boolean aRemovable, boolean aReversible, boolean aRemoveAllOthersWithSameOutput, boolean aRemoveAllOthersWithSameOutputIfTheyHaveSameNBT, boolean aRemoveAllOtherShapedsWithSameOutput, boolean aRemoveAllOtherNativeRecipes, boolean aCheckForCollisions, boolean aOnlyAddIfThereIsAnyRecipeOutputtingThis, boolean aOnlyAddIfResultIsNotNull, boolean aDeleteOnlyIfNoDyeInvolved, boolean aNotAutoCraftable, Object[] aRecipe) {
		if (aOnlyAddIfResultIsNotNull && UT.Stacks.invalid(aResult)) return F;
		aResult = OM.get(aResult);
		if (aResult != null && UT.Stacks.meta(aResult) == W) UT.Stacks.meta(aResult, 0);
		if (aRecipe == null || aRecipe.length <= 0) return F;
		
		boolean tThereWasARecipe = F;
		
		for (byte i = 0; i < aRecipe.length; i++) {
			if (aRecipe[i] instanceof IItemContainer)
			    aRecipe[i] = ((IItemContainer)aRecipe[i]).get(1);
			else if (aRecipe[i] instanceof Enum)
				aRecipe[i] = ((Enum)aRecipe[i]).name();
			else if (!(aRecipe[i] == null || aRecipe[i] instanceof ItemStack || aRecipe[i] instanceof OreDictItemData || aRecipe[i] instanceof String || aRecipe[i] instanceof Character))
				aRecipe[i] = aRecipe[i].toString();
		}
		
		try {
		    String shape = "";
		    int idx = 0;
		    if (aRecipe[idx] instanceof Boolean) throw new IllegalArgumentException();
		    
			ArrayList<Object> tRecipeList = new ArrayList<Object>(Arrays.asList(aRecipe));
			
	        while (aRecipe[idx] instanceof String) {
	            String s = (String)aRecipe[idx++];
	            shape += s;
	            while (s.length() < 3) s+=" ";
	            if (s.length() > 3) throw new IllegalArgumentException();
	            
	            for (char c : s.toCharArray()) {
	            	switch(c) {
	            	case 'b': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.blade					); break;
	            	case 'c': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.crowbar					); break;
	            	case 'd': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.screwdriver				); break;
	            	case 'f': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.file						); break;
	            	case 'h': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.hammer					); break;
	            	case 'i': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.solderingiron			); break;
	            	case 'j': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.solderingmetal			); break;
	            	case 'k': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.knife					); break;
	            	case 'l': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.magnifyingglass			); break;
	            	case 'm': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.mortar					); break;
	            	case 'n': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.monkeywrench				); break;
	            	case 'o': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.bendingcylindersmall		); break;
	            	case 'p': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.drawplate				); break;
	            	case 'r': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.softhammer				); break;
	            	case 's': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.saw						); break;
	            	case 'w': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.wrench					); break;
	            	case 'x': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.wirecutter				); break;
	            	case 'y': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.chisel					); break;
	            	case 'z': tRecipeList.add(c); tRecipeList.add(OreDictToolNames.bendingcylinder			); break;
	            	}
	            }
	        }
	        
			aRecipe = tRecipeList.toArray();
	        
		    if (aRecipe[idx] instanceof Boolean) {
		    	idx++;
		    }
	        HashMap<Character, ItemStack> tItemStackMap = new HashMap<Character, ItemStack>();
	        HashMap<Character, OreDictItemData> tItemDataMap = new HashMap<Character, OreDictItemData>();
	        tItemStackMap.put(' ', null);
	        
	        boolean tRemoveRecipe = T;
	        
	        for (; idx < aRecipe.length; idx += 2) {
				if (aRecipe[idx] == null || aRecipe[idx + 1] == null) {
					if (D1) {
						ERR.println("WARNING: Missing Item for shaped Recipe: " + (aResult==null?"null":aResult.getDisplayName()));
						for (Object tContent : aRecipe) ERR.println(tContent);
					}
					return F;
				}
	            Character chr = (Character)aRecipe[idx];
	            Object in = aRecipe[idx + 1];
	            if (in instanceof ItemStack) {
	                tItemStackMap.put(chr, UT.Stacks.copy((ItemStack)in));
	                tItemDataMap.put(chr, OM.data_((ItemStack)in));
	            } else if (in instanceof OreDictItemData) {
	            	OreDictItemData tData = OreDictManager.INSTANCE.getAutomaticItemData(in.toString());
	            	if (tData == null) tItemDataMap.put(chr, (OreDictItemData)in); else tItemDataMap.put(chr, tData);
	            	ItemStack tStack = OreDictManager.INSTANCE.getFirstOre(in, 1);
	            	if (tStack == null) tRemoveRecipe = F; else tItemStackMap.put(chr, tStack);
	            	in = aRecipe[idx + 1] = in.toString();
	            } else if (in instanceof String) {
	            	OreDictItemData tData = OreDictManager.INSTANCE.getAutomaticItemData(in.toString());
	            	if (tData != null) tItemDataMap.put(chr, tData);
	            	ItemStack tStack = OreDictManager.INSTANCE.getFirstOre(in, 1);
	            	if (tStack == null) tRemoveRecipe = F; else tItemStackMap.put(chr, tStack);
	            } else {
	                throw new IllegalArgumentException();
	            }
	        }
	        
	        if (aReversible && aResult != null) {
		        OreDictItemData[] tData = new OreDictItemData[9];
		        int x = -1;
		        for (char chr : shape.toCharArray()) tData[++x] = tItemDataMap.get(chr);
		        if (UT.Code.containsSomething(tData)) OM.data(aResult, new OreDictItemData(tData));
	        }
	        
	        if (aCheckForCollisions && tRemoveRecipe) {
		        ItemStack[] tRecipe = new ItemStack[9];
		        int x = -1;
		        for (char chr : shape.toCharArray()) {
		        	tRecipe[++x] = tItemStackMap.get(chr);
		            if (tRecipe[x] != null && UT.Stacks.meta(tRecipe[x]) == W) UT.Stacks.meta(tRecipe[x], 0);
			    }
		        tThereWasARecipe = removeRecipe(tRecipe) != null || tThereWasARecipe;
	        }
		} catch(Throwable e) {e.printStackTrace(ERR);}
		
		if (aResult == null || aResult.stackSize <= 0) return F;
		
		if (aRemoveAllOthersWithSameOutput || aRemoveAllOthersWithSameOutputIfTheyHaveSameNBT || aRemoveAllOtherShapedsWithSameOutput || aRemoveAllOtherNativeRecipes)
			tThereWasARecipe = removeRecipeByOutput(aResult, !aRemoveAllOthersWithSameOutputIfTheyHaveSameNBT, aRemoveAllOtherShapedsWithSameOutput, aRemoveAllOtherNativeRecipes, aDeleteOnlyIfNoDyeInvolved) || tThereWasARecipe;
		
		if (aOnlyAddIfThereIsAnyRecipeOutputtingThis && !tThereWasARecipe) {
			ArrayList<IRecipe> tList = (ArrayList<IRecipe>)CraftingManager.getInstance().getRecipeList();
			for (int i = 0; i < tList.size(); i++) {
				IRecipe tRecipe = tList.get(i);
				if (sSpecialRecipeClasses.contains(tRecipe.getClass().getName())) continue;
				if (UT.Stacks.equal(OM.get(tRecipe.getRecipeOutput()), aResult, T)) {
					tThereWasARecipe = T;
					break;
		    	}
			}
		}
		
		if (UT.Stacks.meta(aResult) == W || UT.Stacks.meta(aResult) < 0) UT.Stacks.meta(aResult, 0);
		
		UT.Stacks.update(aResult);
		
		if (tThereWasARecipe || !aOnlyAddIfThereIsAnyRecipeOutputtingThis) {
			if (sBufferCraftingRecipes && aBuffered)
				sBufferRecipeList.add(new AdvancedCraftingShaped(UT.Stacks.copy(aResult), aDismantleable, aRemovable, aKeepNBT, !aNotAutoCraftable, aEnchantmentsAdded, aEnchantmentLevelsAdded, aRecipe).setMirrored(aMirrored));
			else
				GameRegistry.addRecipe(new AdvancedCraftingShaped(UT.Stacks.copy(aResult), aDismantleable, aRemovable, aKeepNBT, !aNotAutoCraftable, aEnchantmentsAdded, aEnchantmentLevelsAdded, aRecipe).setMirrored(aMirrored));
		}
		return T;
	}
	
	/**
	 * Shapeless Crafting Recipes. Deletes conflicting Recipes too.
	 */
	public static boolean addShapelessEnchantingRecipe(ItemStack aResult, Enchantment[] aEnchantmentsAdded, int[] aEnchantmentLevelsAdded, Object[] aRecipe) {
		return addShapelessCraftingRecipe(aResult, aEnchantmentsAdded, aEnchantmentLevelsAdded, T, F, F, F, F, aRecipe);
	}
	
	/**
	 * Shapeless Crafting Recipes. Deletes conflicting Recipes too.
	 */
	public static boolean addShapelessCraftingRecipe(ItemStack aResult, Object[] aRecipe) {
		return addShapelessCraftingRecipe(aResult, RecipeBits.DO_NOT_CHECK_FOR_COLLISIONS | RecipeBits.BUFFERED, aRecipe);
	}
	
	/**
	 * Shapeless Crafting Recipes. Deletes conflicting Recipes too.
	 */
	public static boolean addShapelessCraftingRecipe(ItemStack aResult, long aBitMask, Object[] aRecipe) {
		return addShapelessCraftingRecipe(aResult, new Enchantment[0], new int[0], (aBitMask & RecipeBits.BUFFERED) != 0, (aBitMask & RecipeBits.KEEPNBT) != 0, (aBitMask & RecipeBits.DISMANTLEABLE) != 0, (aBitMask & RecipeBits.NOT_REMOVABLE) == 0, (aBitMask & RecipeBits.NOT_AUTOCRAFTABLE) != 0, aRecipe);
	}
	
	/**
	 * Shapeless Crafting Recipes. Deletes conflicting Recipes too.
	 */
	private static boolean addShapelessCraftingRecipe(ItemStack aResult, Enchantment[] aEnchantmentsAdded, int[] aEnchantmentLevelsAdded, boolean aBuffered, boolean aKeepNBT, boolean aDismantleable, boolean aRemovable, boolean aNotAutoCraftable, Object[] aRecipe) {
		if (aRecipe == null || aRecipe.length <= 0) return F;
		if (aRecipe.length > 9) throw new IllegalArgumentException("Shapeless Recipe has more than 9 Inputs! This would crash NEI!");
		aResult = OM.get(aResult);
		for (byte i = 0; i < aRecipe.length; i++) {
			if (aRecipe[i] instanceof IItemContainer)
			    aRecipe[i] = ((IItemContainer)aRecipe[i]).get(1);
			else if (aRecipe[i] instanceof Enum)
				aRecipe[i] = ((Enum)aRecipe[i]).name();
			else if (!(aRecipe[i] == null || aRecipe[i] instanceof ItemStack || aRecipe[i] instanceof String || aRecipe[i] instanceof Character))
				aRecipe[i] = aRecipe[i].toString();
		}
		try {
	        ItemStack[] tRecipe = new ItemStack[9];
	        int i = 0;
			for (Object tObject : aRecipe) {
				if (tObject == null) {
					if (D1) ERR.println("WARNING: Missing Item for shapeless Recipe: " + (aResult==null?"null":aResult.getDisplayName()));
					for (Object tContent : aRecipe) ERR.println(tContent);
					return F;
				}
				if (tObject instanceof ItemStack) {
					tRecipe[i] = (ItemStack)tObject;
				} else if (tObject instanceof String) {
					tRecipe[i] = OreDictManager.INSTANCE.getFirstOre(tObject, 1);
	            	if (tRecipe[i] == null) break;
				} else if (tObject instanceof Boolean) {
					//
				} else {
	                throw new IllegalArgumentException();
				}
				i++;
			}
	        removeRecipe(tRecipe);
		} catch(Throwable e) {e.printStackTrace(ERR);}
		
		if (aResult == null || aResult.stackSize <= 0) return F;
		
		if (UT.Stacks.meta(aResult) == W || UT.Stacks.meta(aResult) < 0) UT.Stacks.meta(aResult, 0);
		
		UT.Stacks.update(aResult);
		
		if (sBufferCraftingRecipes && aBuffered)
			sBufferRecipeList.add(new AdvancedCraftingShapeless(UT.Stacks.copy(aResult), aDismantleable, aRemovable, aKeepNBT, !aNotAutoCraftable, aEnchantmentsAdded, aEnchantmentLevelsAdded, aRecipe));
		else
			GameRegistry.addRecipe(new AdvancedCraftingShapeless(UT.Stacks.copy(aResult), aDismantleable, aRemovable, aKeepNBT, !aNotAutoCraftable, aEnchantmentsAdded, aEnchantmentLevelsAdded, aRecipe));
		return T;
	}
	
	/**
	 * Removes a Smelting Recipe
	 */
	public static boolean removeFurnaceSmelting(ItemStack aInput) {
		if (aInput != null) {
			for (Object tInput : FurnaceRecipes.smelting().getSmeltingList().keySet()) {
				if (UT.Stacks.valid(tInput) && UT.Stacks.equal(aInput, (ItemStack)tInput, T)) {
					FurnaceRecipes.smelting().getSmeltingList().remove(tInput);
					return T;
				}
			}
		}
		return F;
	}
	
	/**
	 * Removes a Crafting Recipe and gives you the former output of it.
	 * @param aRecipe The content of the Crafting Grid as ItemStackArray with length 9
	 * @return the output of the old Recipe or null if there was nothing.
	 */
    public static ItemStack removeRecipe(ItemStack... aRecipe) {
    	if (aRecipe == null) return null;
    	boolean temp = F;
    	for (byte i = 0; i < aRecipe.length; i++) {
    		if (aRecipe[i] != null) {
    			temp = T;
        		break;
    		}
    	}
    	if (!temp) return null;
    	ItemStack rReturn = null, tReturn = null;
		InventoryCrafting aCrafting = new InventoryCrafting(new Container() {@Override public boolean canInteractWith(EntityPlayer var1) {return F;}}, 3, 3);
		for (int i = 0; i < aRecipe.length && i < 9; i++) aCrafting.setInventorySlotContents(i, aRecipe[i]);
		ArrayList<IRecipe> tList = (ArrayList<IRecipe>)CraftingManager.getInstance().getRecipeList();
		for (int i = 0; i < tList.size(); i++) {try {for (; i < tList.size(); i++) {
			if ((!(tList.get(i) instanceof ICraftingRecipeGT) || ((ICraftingRecipeGT)tList.get(i)).isRemovableByGT()) && tList.get(i).matches(aCrafting, CS.DW)) {
				tReturn = tList.get(i).getCraftingResult(aCrafting);
				if (tReturn != null) {
					rReturn = tReturn;
					tList.remove(i--);
				}
			}
		}} catch(Throwable e) {e.printStackTrace(ERR);}}
		return rReturn;
    }

    public static boolean removeRecipeByOutput(ItemStack aOutput) {
    	return removeRecipeByOutput(aOutput, T, F, F, F);
    }

    public static Collection<String> sNativeRecipeClasses = new HashSet<String>(), sSpecialRecipeClasses = new HashSet<String>();
    
    static {
    	sNativeRecipeClasses.add(ShapedRecipes.class.getName());
    	sNativeRecipeClasses.add(ShapedOreRecipe.class.getName());
    	sNativeRecipeClasses.add(AdvancedCraftingShaped.class.getName());
    	sNativeRecipeClasses.add(ShapelessRecipes.class.getName());
    	sNativeRecipeClasses.add(ShapelessOreRecipe.class.getName());
    	sNativeRecipeClasses.add(AdvancedCraftingShapeless.class.getName());
    	sNativeRecipeClasses.add("ic2.core.AdvRecipe");
    	sNativeRecipeClasses.add("ic2.core.AdvShapelessRecipe");
    	sNativeRecipeClasses.add("appeng.recipes.game.ShapedRecipe");
    	sNativeRecipeClasses.add("appeng.recipes.game.ShapelessRecipe");
    	sNativeRecipeClasses.add("forestry.core.utils.ShapedRecipeCustom");
    	
    	// Recipe Classes, which should never be removed.
    	sSpecialRecipeClasses.add(net.minecraft.item.crafting.RecipeFireworks.class.getName());
    	sSpecialRecipeClasses.add(net.minecraft.item.crafting.RecipesArmorDyes.class.getName());
    	sSpecialRecipeClasses.add(net.minecraft.item.crafting.RecipeBookCloning.class.getName());
    	sSpecialRecipeClasses.add(net.minecraft.item.crafting.RecipesMapCloning.class.getName());
    	sSpecialRecipeClasses.add(net.minecraft.item.crafting.RecipesMapExtending.class.getName());
    	sSpecialRecipeClasses.add("jds.bibliocraft.BiblioSpecialRecipes");
    	sSpecialRecipeClasses.add("dan200.qcraft.shared.EntangledQBlockRecipe");
    	sSpecialRecipeClasses.add("dan200.qcraft.shared.EntangledQuantumComputerRecipe");
    	sSpecialRecipeClasses.add("dan200.qcraft.shared.QBlockRecipe");
    	sSpecialRecipeClasses.add("appeng.recipes.game.FacadeRecipe");
    	sSpecialRecipeClasses.add("appeng.recipes.game.DisassembleRecipe");
    	sSpecialRecipeClasses.add("mods.railcraft.common.carts.LocomotivePaintingRecipe");
    	sSpecialRecipeClasses.add("mods.railcraft.common.util.crafting.RotorRepairRecipe");
    	sSpecialRecipeClasses.add("mods.railcraft.common.util.crafting.RoutingTableCopyRecipe");
    	sSpecialRecipeClasses.add("mods.railcraft.common.util.crafting.RoutingTicketCopyRecipe");
    	sSpecialRecipeClasses.add("mods.railcraft.common.util.crafting.TankCartFilterRecipe");
    	sSpecialRecipeClasses.add("mods.railcraft.common.emblems.LocomotiveEmblemRecipe");
    	sSpecialRecipeClasses.add("mods.railcraft.common.emblems.EmblemPostColorRecipe");
    	sSpecialRecipeClasses.add("mods.railcraft.common.emblems.EmblemPostEmblemRecipe");
    	sSpecialRecipeClasses.add("mods.immibis.redlogic.interaction.RecipeDyeLumarButton");
    	sSpecialRecipeClasses.add("thaumcraft.common.items.armor.RecipesRobeArmorDyes");
    	sSpecialRecipeClasses.add("thaumcraft.common.items.armor.RecipesVoidRobeArmorDyes");
    	sSpecialRecipeClasses.add("thaumcraft.common.lib.crafting.ShapelessNBTOreRecipe");
    	sSpecialRecipeClasses.add("twilightforest.item.TFMapCloningRecipe");
    	sSpecialRecipeClasses.add("forestry.lepidopterology.MatingRecipe");
    	sSpecialRecipeClasses.add("micdoodle8.mods.galacticraft.planets.asteroids.recipe.CanisterRecipes");
    	sSpecialRecipeClasses.add("shedar.mods.ic2.nuclearcontrol.StorageArrayRecipe");
    }
    
    private static final ArrayListNoNulls<List<ItemStack>> OREDICT_DYE_LISTS = new ArrayListNoNulls<List<ItemStack>>();
    static {for (String tDye : DYE_OREDICTS) OREDICT_DYE_LISTS.add(OreDictionary.getOres(tDye));}
    
	/**
	 * Removes a Crafting Recipe.
	 * @param aOutput The output of the Recipe.
	 * @return if it has removed at least one Recipe.
	 */
    public static boolean removeRecipeByOutput(ItemStack aOutput, boolean aIgnoreNBT, boolean aNotRemoveShapelessRecipes, boolean aOnlyRemoveNativeHandlers, boolean aDontRemoveDyeingRecipes) {
    	if (UT.Stacks.invalid(aOutput)) return F;
    	boolean rReturn = F;
		ArrayList<IRecipe> tList = (ArrayList<IRecipe>)CraftingManager.getInstance().getRecipeList();
		aOutput = OM.get_(aOutput);
		for (int i = 0; i < tList.size(); i++) {
			IRecipe tRecipe = tList.get(i);
			if (aNotRemoveShapelessRecipes && (tRecipe instanceof ShapelessRecipes || tRecipe instanceof ShapelessOreRecipe)) continue;
			if (aOnlyRemoveNativeHandlers) {
				if (!sNativeRecipeClasses.contains(tRecipe.getClass().getName())) continue;
			} else {
				if (sSpecialRecipeClasses.contains(tRecipe.getClass().getName())) continue;
			}
			if (tRecipe instanceof ICraftingRecipeGT && !((ICraftingRecipeGT)tRecipe).isRemovableByGT()) continue;
			if (!UT.Stacks.equal(OM.get(tRecipe.getRecipeOutput()), aOutput, aIgnoreNBT)) continue;
			if (aDontRemoveDyeingRecipes) {
				if (tRecipe instanceof ShapedOreRecipe		) {boolean temp = F; for (Object tObject : ((ShapedOreRecipe	)tRecipe).getInput()) if (OREDICT_DYE_LISTS.contains(tObject)) {temp = T; break;} if (temp) continue;}
				if (tRecipe instanceof ShapelessOreRecipe	) {boolean temp = F; for (Object tObject : ((ShapelessOreRecipe	)tRecipe).getInput()) if (OREDICT_DYE_LISTS.contains(tObject)) {temp = T; break;} if (temp) continue;}
			}
			tList.remove(i--);
			rReturn = T;
		}
		return rReturn;
    }
    
    /**
     * Checks all Crafting Handlers for Recipe Output
     */
    public static ItemStack getAllRecipeOutput(World aWorld, ItemStack... aRecipe) {
    	if (aRecipe == null || aRecipe.length == 0) return null;
    	
    	if (aWorld == null) aWorld = CS.DW;
    	
    	boolean temp = F;
    	for (byte i = 0; i < aRecipe.length; i++) {
    		if (aRecipe[i] != null) {
    			temp = T;
        		break;
    		}
    	}
    	if (!temp) return null;
		InventoryCrafting aCrafting = new InventoryCrafting(new Container() {@Override public boolean canInteractWith(EntityPlayer var1) {return F;}}, 3, 3);
		for (int i = 0; i < 9 && i < aRecipe.length; i++) aCrafting.setInventorySlotContents(i, aRecipe[i]);
		List<IRecipe> tList = CraftingManager.getInstance().getRecipeList();
		synchronized(sAllRecipeList) {
			if (sAllRecipeList.size() != tList.size()) {
				sAllRecipeList.clear();
				sAllRecipeList.addAll(tList);
			}
			for (int i = 0, j = sAllRecipeList.size(); i < j; i++) {
				IRecipe tRecipe = sAllRecipeList.get(i);
				if (tRecipe.matches(aCrafting, aWorld)) {
					if (i > 10) {
						sAllRecipeList.remove(i);
						sAllRecipeList.add(i-10, tRecipe);
					}
					return tRecipe.getCraftingResult(aCrafting);
				}
			}
		}
		
        int tIndex = 0;
        ItemStack tStack1 = null, tStack2 = null;
        for (int i = 0, j = aCrafting.getSizeInventory(); i < j; i++) {
            ItemStack tStack = aCrafting.getStackInSlot(i);
            if (tStack != null) {
                if (tIndex == 0) tStack1 = tStack;
                if (tIndex == 1) tStack2 = tStack;
                tIndex++;
            }
        }
        
        if (tIndex == 2) {
            assert tStack1 != null && tStack2 != null;
        	if (tStack1.getItem() == tStack2.getItem() && tStack1.getItem().isRepairable()) {
        		int tNewDamage = UT.Stacks.meta(tStack1)+UT.Stacks.meta(tStack2)+(tStack1.getMaxDamage()/-20)-tStack1.getMaxDamage();
                return UT.Stacks.make(tStack1.getItem(), 1, tNewDamage<0?0:tNewDamage);
            }
        }
		
		return null;
    }
    
    /**
     * Gives you a copy of the Output from a Crafting Recipe
     * Used for Recipe Detection.
     */
    public static ItemStack getRecipeOutput(ItemStack... aRecipe) {
    	return getRecipeOutput(F, aRecipe);
    }
    
    /**
     * Gives you a copy of the Output from a Crafting Recipe
     * Used for Recipe Detection.
     */
    public static ItemStack getRecipeOutput(boolean aUncopiedStack, ItemStack... aRecipe) {
    	if (aRecipe == null) return null;
    	boolean temp = F;
    	for (byte i = 0; i < aRecipe.length; i++) {
    		if (aRecipe[i] != null) {
    			temp = T;
        		break;
    		}
    	}
    	if (!temp) return null;
		InventoryCrafting aCrafting = new InventoryCrafting(new Container() {@Override public boolean canInteractWith(EntityPlayer var1) {return F;}}, 3, 3);
		for (int i = 0; i < 9 && i < aRecipe.length; i++) aCrafting.setInventorySlotContents(i, aRecipe[i]);
		ArrayList<IRecipe> tList = (ArrayList<IRecipe>)CraftingManager.getInstance().getRecipeList();
		for (int i = 0; i < tList.size(); i++) {temp = F;
			try {
				temp = tList.get(i).matches(aCrafting, CS.DW);
			} catch(Throwable e) {e.printStackTrace(ERR);}
			if (temp) {
				ItemStack tOutput = aUncopiedStack?tList.get(i).getRecipeOutput():tList.get(i).getCraftingResult(aCrafting);
				if (tOutput == null || tOutput.stackSize <= 0) {
					// Seriously, who would ever do that shit?
					if (Abstract_Mod.sFinalized < Abstract_Mod.sModCountUsingGTAPI) throw new IllegalArgumentException("Seems another Mod added a Crafting Recipe with null Output. Tell the Developer of said Mod to fix that. Recipe Contents: " + UT.Stacks.names(aRecipe));
				} else {
					if (aUncopiedStack) return tOutput;
					return UT.Stacks.copy(tOutput);
				}
			}
		}
		return null;
    }
    
    /**
     * Gives you a list of the Outputs from a Crafting Recipe
     * If you have multiple Mods, which add Bronze Armor for example
     */
    public static ArrayList<ItemStack> getRecipeOutputs(ItemStack... aRecipe) {
    	return getRecipeOutputs(CraftingManager.getInstance().getRecipeList(), F, aRecipe);
    }
    
    /**
     * Gives you a list of the Outputs from a Crafting Recipe
     * If you have multiple Mods, which add Bronze Armor for example
     */
    public static ArrayList<ItemStack> getRecipeOutputs(List<IRecipe> aList, boolean aDeleteFromList, ItemStack... aRecipe) {
    	ArrayList<ItemStack> rList = new ArrayListNoNulls<ItemStack>();
    	if (aList == null || aRecipe == null) return rList;
    	boolean temp = F;
    	for (byte i = 0; i < aRecipe.length; i++) {
    		if (aRecipe[i] != null) {
    			temp = T;
        		break;
    		}
    	}
    	if (!temp) return rList;
    	InventoryCrafting aCrafting = new InventoryCrafting(new Container() {@Override
		public boolean canInteractWith(EntityPlayer var1) {return F;}}, 3, 3);
		for (int i = 0; i < 9 && i < aRecipe.length; i++) aCrafting.setInventorySlotContents(i, aRecipe[i]);
		for (int i = 0; i < aList.size(); i++) {
			temp = F;
			try {
				temp = aList.get(i).matches(aCrafting, CS.DW);
			} catch(Throwable e) {e.printStackTrace(ERR);}
			if (temp) {
				ItemStack tOutput = aList.get(i).getCraftingResult(aCrafting);
				if (tOutput == null || tOutput.stackSize <= 0) {
					// Seriously, who would ever do that shit?
					if (Abstract_Mod.sFinalized < Abstract_Mod.sModCountUsingGTAPI) throw new IllegalArgumentException("Seems another Mod added a Crafting Recipe with null Output. Tell the Developer of said Mod to fix that. Recipe Contents: " + UT.Stacks.names(aRecipe));
				} else {
					rList.add(UT.Stacks.copy(tOutput));
					if (aDeleteFromList) aList.remove(i--);
				}
			}
		}
		return rList;
    }
    
    /**
     * Used in my own Macerator. Decreases StackSize of the Input if wanted.
     */
    public static ItemStack getMaceratorOutput(ItemStack aInput, boolean aRemoveInput, ItemStack aOutputSlot) {
    	return UT.Stacks.copy(getMachineOutput(aInput, getMaceratorRecipeList(), aRemoveInput, new NBTTagCompound(), aOutputSlot)[0]);
    }
    
    /**
     * Used in my own Extractor. Decreases StackSize of the Input if wanted.
     */
    public static ItemStack getExtractorOutput(ItemStack aInput, boolean aRemoveInput, ItemStack aOutputSlot) {
    	return UT.Stacks.copy(getMachineOutput(aInput, getExtractorRecipeList(), aRemoveInput, new NBTTagCompound(), aOutputSlot)[0]);
    }
    
    /**
     * Used in my own Compressor. Decreases StackSize of the Input if wanted.
     */
    public static ItemStack getCompressorOutput(ItemStack aInput, boolean aRemoveInput, ItemStack aOutputSlot) {
    	return UT.Stacks.copy(getMachineOutput(aInput, getCompressorRecipeList(), aRemoveInput, new NBTTagCompound(), aOutputSlot)[0]);
    }
    
    /**
     * Used in my own Furnace.
     */
    public static ItemStack getSmeltingOutput(ItemStack aInput, boolean aRemoveInput, ItemStack aOutputSlot) {
    	if (aInput == null || aInput.stackSize < 1) return null;
    	ItemStack rStack = OM.get(FurnaceRecipes.smelting().getSmeltingResult(aInput));
    	if (rStack != null && (aOutputSlot == null || (UT.Stacks.equal(rStack, aOutputSlot) && rStack.stackSize + aOutputSlot.stackSize <= aOutputSlot.getMaxStackSize()))) {
			if (aRemoveInput) aInput.stackSize--;
			return rStack;
		}
    	return null;
    }
    
    /**
     * Used in my own Machines. Decreases StackSize of the Input if wanted.
     * 
     * Checks also if there is enough Space in the Output Slots.
     */
    public static ItemStack[] getMachineOutput(ItemStack aInput, Map<IRecipeInput, RecipeOutput> aRecipeList, boolean aRemoveInput, NBTTagCompound rRecipeMetaData, ItemStack... aOutputSlots) {
    	if (aOutputSlots == null || aOutputSlots.length <= 0) return new ItemStack[0];
    	if (aInput == null) return new ItemStack[aOutputSlots.length];
    	try {
			for (Entry<IRecipeInput, RecipeOutput> tEntry : aRecipeList.entrySet()) {
				if (tEntry.getKey().matches(aInput)) {
					if (tEntry.getKey().getAmount() <= aInput.stackSize) {
						ItemStack[] tList = (ItemStack[])tEntry.getValue().items.toArray();
						if (tList.length == 0) break;
						ItemStack[] rList = new ItemStack[aOutputSlots.length];
						rRecipeMetaData.setTag("return", tEntry.getValue().metadata);
						for (byte i = 0; i < aOutputSlots.length && i < tList.length; i++) {
							if (tList[i] != null) {
								if (aOutputSlots[i] == null || (UT.Stacks.equal(tList[i], aOutputSlots[i]) && tList[i].stackSize + aOutputSlots[i].stackSize <= aOutputSlots[i].getMaxStackSize())) {
									rList[i] = UT.Stacks.copy(tList[i]);
								} else {
							    	return new ItemStack[aOutputSlots.length];
								}
							}
						}
						
						if (aRemoveInput) aInput.stackSize-=tEntry.getKey().getAmount();
						return rList;
					}
					break;
				}
			}
    	} catch(Throwable e) {
    		if (D1) e.printStackTrace(ERR);
    	}
    	return new ItemStack[aOutputSlots.length];
    }
    
	/**
	 * Charges an Electric Item. Only if it's a valid Electric Item of course.
	 * This forces the Usage of proper Voltages (so not the transfer limits defined by the Items) unless you ignore the Transfer Limit.
	 * If aTier is Integer.MAX_VALUE it will ignore Tier based Limitations.
	 * @return the actually used Energy.
	 */
	public static int chargeElectricItem(ItemStack aStack, int aCharge, int aTier, boolean aIgnoreLimit, boolean aSimulate) {
		try {
			if (isElectricItem(aStack)) {
				int tTier = ((ic2.api.item.IElectricItem)aStack.getItem()).getTier(aStack);
				if (tTier < 0 || tTier == aTier || aTier == Integer.MAX_VALUE) {
					if (!aIgnoreLimit && tTier >= 0) aCharge = (int)Math.min(aCharge, V[Math.max(0, Math.min(V.length-1, tTier))]);
					if (aCharge > 0) {
						int rCharge = (int)Math.max(0.0, ic2.api.item.ElectricItem.manager.charge(aStack, aCharge, tTier, T, aSimulate));
						return rCharge + (rCharge * 4 > aTier ? aTier : 0);
					}
				}
			}
		} catch (Throwable e) {/*Do nothing*/}
		return 0;
	}
	
	/**
	 * Discharges an Electric Item. Only if it's a valid Electric Item for that of course.
	 * This forces the Usage of proper Voltages (so not the transfer limits defined by the Items) unless you ignore the Transfer Limit.
	 * If aTier is Integer.MAX_VALUE it will ignore Tier based Limitations.
	 * @return the Energy got from the Item.
	 */
	public static int dischargeElectricItem(ItemStack aStack, int aCharge, int aTier, boolean aIgnoreLimit, boolean aSimulate, boolean aIgnoreDischargability) {
		try {
//			if (isElectricItem(aStack) &&  (aIgnoreDischargability || ((ic2.api.item.IElectricItem)aStack.getItem()).canProvideEnergy(aStack))) {
			if (isElectricItem(aStack)) {
				int tTier = ((ic2.api.item.IElectricItem)aStack.getItem()).getTier(aStack);
				if (tTier < 0 || tTier == aTier || aTier == Integer.MAX_VALUE) {
					if (!aIgnoreLimit && tTier >= 0) aCharge = (int)Math.min(aCharge, V[Math.max(0, Math.min(V.length-1, tTier))]);
					if (aCharge > 0) {
//						int rCharge = Math.max(0, ic2.api.item.ElectricItem.manager.discharge(aStack, aCharge + (aCharge * 4 > aTier ? aTier : 0), tTier, T, aSimulate));
						int rCharge = (int)Math.max(0, ic2.api.item.ElectricItem.manager.discharge(aStack, aCharge + (aCharge * 4 > aTier ? aTier : 0), tTier, T, !aIgnoreDischargability, aSimulate));
						return rCharge - (rCharge * 4 > aTier ? aTier : 0);
					}
				}
			}
		} catch (Throwable e) {/*Do nothing*/}
		return 0;
	}
	
	/**
	 * Uses an Electric Item. Only if it's a valid Electric Item for that of course.
	 * @return if the action was successful
	 */
	public static boolean canUseElectricItem(ItemStack aStack, int aCharge) {
		try {
			if (isElectricItem(aStack)) {
				return ic2.api.item.ElectricItem.manager.canUse(aStack, aCharge);
			}
		} catch (Throwable e) {/*Do nothing*/}
		return F;
	}
	
	/**
	 * Uses an Electric Item. Only if it's a valid Electric Item for that of course.
	 * @return if the action was successful
	 */
	public static boolean useElectricItem(ItemStack aStack, int aCharge, EntityPlayer aPlayer) {
		try {
			if (isElectricItem(aStack)) {
				ic2.api.item.ElectricItem.manager.use(aStack, 0, aPlayer);
				if (ic2.api.item.ElectricItem.manager.canUse(aStack, aCharge)) {
					return ic2.api.item.ElectricItem.manager.use(aStack, aCharge, aPlayer);
				}
			}
		} catch (Throwable e) {/*Do nothing*/}
		return F;
	}
	
	/**
	 * Uses an Item. Tries to discharge in case of Electric Items
	 */
	public static boolean damageOrDechargeItem(ItemStack aStack, int aDamage, int aDecharge, EntityLivingBase aPlayer) {
		if (UT.Stacks.invalid(aStack) || (aStack.getMaxStackSize() <= 1 && aStack.stackSize > 1)) return F;
		if (aPlayer != null && aPlayer instanceof EntityPlayer && UT.Entities.hasInfiniteItems(aPlayer)) return T;
		if (aStack.getItem() instanceof IItemDamagable) {
			return ((IItemDamagable)aStack.getItem()).doDamageToItem(aStack, aDamage);
		} else if (GT_ModHandler.isElectricItem(aStack)) {
			if (canUseElectricItem(aStack, aDecharge)) {
				if (aPlayer != null && aPlayer instanceof EntityPlayer) {
					return GT_ModHandler.useElectricItem(aStack, aDecharge, (EntityPlayer)aPlayer);
				}
				return GT_ModHandler.dischargeElectricItem(aStack, aDecharge, Integer.MAX_VALUE, T, F, T) >= aDecharge;
			}
		} else if (aStack.getItem().isDamageable()) {
			if (aPlayer == null) {
				aStack.setItemDamage(aStack.getItemDamage() + aDamage);
			} else {
				aStack.damageItem(aDamage, aPlayer);
			}
			if (aStack.getItemDamage() >= aStack.getMaxDamage()) {
				aStack.setItemDamage(aStack.getMaxDamage()+1);
				ItemStack tStack = UT.Stacks.container(aStack, T);
				if (tStack != null) {
					aStack.func_150996_a(tStack.getItem());
					aStack.setItemDamage(tStack.getItemDamage());
					aStack.stackSize = tStack.stackSize;
					aStack.setTagCompound(tStack.getTagCompound());
				}
			}
			return T;
		}
		return F;
	}
	
	/**
	 * Uses a Soldering Iron
	 */
	public static boolean useSolderingIron(ItemStack aStack, EntityLivingBase aPlayer) {
		if (aPlayer == null || aStack == null) return F;
		if (ToolsGT.contains(TOOL_solderingtool, aStack)) {
			if (aPlayer instanceof EntityPlayer) {
				EntityPlayer tPlayer = (EntityPlayer)aPlayer;
				if (UT.Entities.hasInfiniteItems(tPlayer)) return T;
				for (int i = 0; i < tPlayer.inventory.mainInventory.length; i++) {
					if (ToolsGT.contains(TOOL_solderingmetal, tPlayer.inventory.mainInventory[i])) {
						if (damageOrDechargeItem(aStack, 1, 1000, tPlayer)) {
							if (tPlayer.inventory.mainInventory[i].getItemDamage() >= tPlayer.inventory.mainInventory[i].getMaxDamage()) tPlayer.inventory.mainInventory[i] = null;
						    if (damageOrDechargeItem(tPlayer.inventory.mainInventory[i], 1, 1000, tPlayer)) {
								if (tPlayer.inventory.mainInventory[i].getItemDamage() >= tPlayer.inventory.mainInventory[i].getMaxDamage()) tPlayer.inventory.mainInventory[i] = null;
							    if (tPlayer.inventoryContainer != null) tPlayer.inventoryContainer.detectAndSendChanges();
								return T;
							}
						}
					}
				}
			} else {
				damageOrDechargeItem(aStack, 1, 1000, aPlayer);
				return T;
			}
		}
		return F;
	}
	
	/**
	 * Is this an electric Item, which can charge other Items?
	 */
	public static boolean isChargerItem(ItemStack aStack) {
		try {
			if (isElectricItem(aStack)) {
				return ((ic2.api.item.IElectricItem)aStack.getItem()).canProvideEnergy(aStack);
			}
		} catch (Throwable e) {/*Do nothing*/}
		return F;
	}
	
	/**
	 * Is this an electric Item?
	 */
	public static boolean isElectricItem(ItemStack aStack) {
		try {
			return aStack != null && aStack.getItem() instanceof ic2.api.item.IElectricItem && ((IElectricItem)aStack.getItem()).getTier(aStack) < Integer.MAX_VALUE;
		} catch (Throwable e) {/*Do nothing*/}
		return F;
	}
	
	public static boolean isElectricItem(ItemStack aStack, byte aTier) {
		try {
			return aStack != null && aStack.getItem() instanceof ic2.api.item.IElectricItem && ((IElectricItem)aStack.getItem()).getTier(aStack) == aTier;
		} catch (Throwable e) {/*Do nothing*/}
		return F;
	}
	
	public static boolean isReactorItem(ItemStack aStack) {
		try {
			return aStack != null && aStack.getItem() instanceof ic2.api.reactor.IReactorComponent;
		} catch (Throwable e) {/*Do nothing*/}
		return F;
	}
	
	/**
	 * Copy of the original Helper Class of Thermal Expansion, just to make sure it works even when other Mods include TE-APIs
	 */
	public static class ThermalExpansion {
		public static void addFurnaceRecipe(int energy, ItemStack input, ItemStack output) {
		    NBTTagCompound toSend = new NBTTagCompound();
		    toSend.setInteger("energy", energy);
		    toSend.setTag("input", new NBTTagCompound());
		    toSend.setTag("output", new NBTTagCompound());
		    input.writeToNBT(toSend.getCompoundTag("input"));
		    output.writeToNBT(toSend.getCompoundTag("output"));
		    FMLInterModComms.sendMessage("ThermalExpansion", "FurnaceRecipe", toSend);
	    }
		
	    public static void addPulverizerRecipe(int energy, ItemStack input, ItemStack primaryOutput) {
	        addPulverizerRecipe(energy, input, primaryOutput, null, 0);
	    }
	    
	    public static void addPulverizerRecipe(int energy, ItemStack input, ItemStack primaryOutput, ItemStack secondaryOutput) {
	    	addPulverizerRecipe(energy, input, primaryOutput, secondaryOutput, 100);
	    }
	    
	    public static void addPulverizerRecipe(int energy, ItemStack input, ItemStack primaryOutput, ItemStack secondaryOutput, int secondaryChance) {
	    	if (input == null || primaryOutput == null) return;
	    	NBTTagCompound toSend = new NBTTagCompound();
	        toSend.setInteger("energy", energy);
	        toSend.setTag("input", new NBTTagCompound());
	        toSend.setTag("primaryOutput", new NBTTagCompound());
	        toSend.setTag("secondaryOutput", new NBTTagCompound());
	        input.writeToNBT(toSend.getCompoundTag("input"));
	        primaryOutput.writeToNBT(toSend.getCompoundTag("primaryOutput"));
	        if (secondaryOutput != null) secondaryOutput.writeToNBT(toSend.getCompoundTag("secondaryOutput"));
	        toSend.setInteger("secondaryChance", secondaryChance);
	        FMLInterModComms.sendMessage("ThermalExpansion", "PulverizerRecipe", toSend);
	    }
	    
	    public static void addSawmillRecipe(int energy, ItemStack input, ItemStack primaryOutput) {
	        addSawmillRecipe(energy, input, primaryOutput, null, 0);
	    }
	    
	    public static void addSawmillRecipe(int energy, ItemStack input, ItemStack primaryOutput, ItemStack secondaryOutput) {
	        addSawmillRecipe(energy, input, primaryOutput, secondaryOutput, 100);
	    }
	    
	    public static void addSawmillRecipe(int energy, ItemStack input, ItemStack primaryOutput, ItemStack secondaryOutput, int secondaryChance) {
	    	if (input == null || primaryOutput == null) return;
	    	NBTTagCompound toSend = new NBTTagCompound();
	        toSend.setInteger("energy", energy);
	        toSend.setTag("input", new NBTTagCompound());
	        toSend.setTag("primaryOutput", new NBTTagCompound());
	        toSend.setTag("secondaryOutput", new NBTTagCompound());
	        input.writeToNBT(toSend.getCompoundTag("input"));
	        primaryOutput.writeToNBT(toSend.getCompoundTag("primaryOutput"));
	        if (secondaryOutput != null) secondaryOutput.writeToNBT(toSend.getCompoundTag("secondaryOutput"));
	        toSend.setInteger("secondaryChance", secondaryChance);
	        FMLInterModComms.sendMessage("ThermalExpansion", "SawmillRecipe", toSend);
	    }
	    
	    public static void addSmelterRecipe(int energy, ItemStack primaryInput, ItemStack secondaryInput, ItemStack primaryOutput) {
	        addSmelterRecipe(energy, primaryInput, secondaryInput, primaryOutput, null, 0);
	    }
	    
	    public static void addSmelterRecipe(int energy, ItemStack primaryInput, ItemStack secondaryInput, ItemStack primaryOutput, ItemStack secondaryOutput) {
	        addSmelterRecipe(energy, primaryInput, secondaryInput, primaryOutput, secondaryOutput, 100);
	    }
	    
	    public static void addSmelterRecipe(int energy, ItemStack primaryInput, ItemStack secondaryInput, ItemStack primaryOutput, ItemStack secondaryOutput, int secondaryChance) {
	    	if (primaryInput == null || secondaryInput == null || primaryOutput == null) return;
	    	NBTTagCompound toSend = new NBTTagCompound();
	        toSend.setInteger("energy", energy);
	        toSend.setTag("primaryInput", new NBTTagCompound());
	        toSend.setTag("secondaryInput", new NBTTagCompound());
	        toSend.setTag("primaryOutput", new NBTTagCompound());
	        toSend.setTag("secondaryOutput", new NBTTagCompound());
	        primaryInput.writeToNBT(toSend.getCompoundTag("primaryInput"));
	        secondaryInput.writeToNBT(toSend.getCompoundTag("secondaryInput"));
	        primaryOutput.writeToNBT(toSend.getCompoundTag("primaryOutput"));
	        if (secondaryOutput != null) secondaryOutput.writeToNBT(toSend.getCompoundTag("secondaryOutput"));
	        toSend.setInteger("secondaryChance", secondaryChance);
	        FMLInterModComms.sendMessage("ThermalExpansion", "SmelterRecipe", toSend);
	    }
	    
	    public static void addSmelterBlastOre(OreDictMaterial aMaterial) {
	        NBTTagCompound toSend = new NBTTagCompound();
	        toSend.setString("oreType", aMaterial.toString());
	        FMLInterModComms.sendMessage("ThermalExpansion", "SmelterBlastOreType", toSend);
	    }
	    
	    public static void addCrucibleRecipe(int energy, ItemStack input, FluidStack output) {
	    	if (input == null || output == null) return;
	    	NBTTagCompound toSend = new NBTTagCompound();
	        toSend.setInteger("energy", energy);
	        toSend.setTag("input", new NBTTagCompound());
	        toSend.setTag("output", new NBTTagCompound());
	        input.writeToNBT(toSend.getCompoundTag("input"));
	        output.writeToNBT(toSend.getCompoundTag("output"));
	        FMLInterModComms.sendMessage("ThermalExpansion", "CrucibleRecipe", toSend);
	    }
	    
	    public static void addTransposerFill(int energy, ItemStack input, ItemStack output, FluidStack fluid, boolean reversible) {
	    	if (input == null || output == null || fluid == null) return;
	    	NBTTagCompound toSend = new NBTTagCompound();
	        toSend.setInteger("energy", energy);
	        toSend.setTag("input", new NBTTagCompound());
	        toSend.setTag("output", new NBTTagCompound());
	        toSend.setTag("fluid", new NBTTagCompound());
	        input.writeToNBT(toSend.getCompoundTag("input"));
	        output.writeToNBT(toSend.getCompoundTag("output"));
	        UT.NBT.setBoolean(toSend, "reversible", reversible);
	        fluid.writeToNBT(toSend.getCompoundTag("fluid"));
	        FMLInterModComms.sendMessage("ThermalExpansion", "TransposerFillRecipe", toSend);
	    }
	    
	    public static void addTransposerExtract(int energy, ItemStack input, ItemStack output, FluidStack fluid, int chance, boolean reversible) {
	    	if (input == null || output == null || fluid == null) return;
	    	NBTTagCompound toSend = new NBTTagCompound();
	        toSend.setInteger("energy", energy);
	        toSend.setTag("input", new NBTTagCompound());
	        toSend.setTag("output", new NBTTagCompound());
	        toSend.setTag("fluid", new NBTTagCompound());
	        input.writeToNBT(toSend.getCompoundTag("input"));
	        output.writeToNBT(toSend.getCompoundTag("output"));
	        UT.NBT.setBoolean(toSend, "reversible", reversible);
	        toSend.setInteger("chance", chance);
	        fluid.writeToNBT(toSend.getCompoundTag("fluid"));
	        FMLInterModComms.sendMessage("ThermalExpansion", "TransposerExtractRecipe", toSend);
	    }
	    
	    public static void addMagmaticFuel(String fluidName, int energy) {
	        NBTTagCompound toSend = new NBTTagCompound();
	        toSend.setString("fluidName", fluidName);
	        toSend.setInteger("energy", energy);
	        FMLInterModComms.sendMessage("ThermalExpansion", "MagmaticFuel", toSend);
	    }
	    
	    public static void addCompressionFuel(String fluidName, int energy) {
	        NBTTagCompound toSend = new NBTTagCompound();
	        toSend.setString("fluidName", fluidName);
	        toSend.setInteger("energy", energy);
	        FMLInterModComms.sendMessage("ThermalExpansion", "CompressionFuel", toSend);
	    }
	    
	    public static void addCoolant(String fluidName, int energy) {
	        NBTTagCompound toSend = new NBTTagCompound();
	        toSend.setString("fluidName", fluidName);
	        toSend.setInteger("energy", energy);
	        FMLInterModComms.sendMessage("ThermalExpansion", "Coolant", toSend);
	    }
	}
}